        .model tiny
        .code
        .286
        org 100h
begin:  jmp end_of_tsr

call_user_isr:
        pusha
        mov     cx,word ptr cs:[pos_x]
        mov     dx,word ptr cs:[pos_y]
        sub     di,di;cs:[x_move]
        sub     si,si;cs:[y_move]
        mov     word ptr cs:[x_move],0
        mov     word ptr cs:[y_move],0
        mov     bl,cs:[buttons]
        xor     bh,bh
        call    dword ptr cs:[user_subroutine]
        popa
        ret

new_isr:
        push    ax
        push    bx
        push    cx
        push    dx
        push    di
        push    si
        push    bp
        push    es
        push    ds

        push    cs
        pop     ds

        mov     DX,[COMAddres]
        add     DX,5
        in      AL,DX
        test    al,1                    ; ⮢?
        jz      COMError
;  
        mov     DX,[COMAddres]
        in      AL,DX

;  訩 騩 
        and   AL,01111111b              ; !!!!!!!!??????????
; । 浪  ਭ 
        cmp     [ByteNumber],0
        je      FirstByte
        cmp     [ByteNumber],1
        je      SecondByte
        cmp     [ByteNumber],2
        je      ThirdByte
        jmp     COMError

; ࠭   
FirstByte:
        cmp     AL,40h                  ; ஢ઠ  
        jb      COMError
        mov     [Byte_1],AL
        inc     [ByteNumber]            ; 㢥 稪
        jmp     Isr_Quit
; ࠭ ன  
SecondByte:
        cmp     AL,40h                  ; ஢ઠ  
        jae     COMError
        mov     [Byte_2],AL
        inc     [ByteNumber]            ; 㢥 稪
        jmp     Isr_Quit
; ࠭ ⨩  
ThirdByte:
        cmp     AL,40h                  ; ஢ઠ  
        jae     COMError
        mov     [Byte_3],AL
        mov     [ByteNumber],0          ;
; (    ਭ ).
        jmp     COM_Ok
COMError:
        mov     [ByteNumber],0
        jmp     Isr_Quit
COM_Ok:

        cmp     [sm_flag],1
        jne     no_restore
        call    Get_Video_Adr
        mov     ax,word ptr es:[di]
        xor     ah,7Fh
        stosw

no_restore:

; ਡ ६饭  X  न X
        mov     AL,byte ptr [Byte_1]
        shl     AL,6
        or      AL,byte ptr [Byte_2]
        cbw
        mov     [x_move],ax
        add     AX,word ptr [pos_x]
        js      X_Zero
        cmp     AX,[x_max]
        jbe     X_Set
        mov     AX,[x_max]
        jmp     X_Set
X_Zero: xor     ax,ax
X_Set:  mov     [pos_x],AX

        mov     AL,byte ptr [Byte_1]
        and     AL,00001100b
        shl     AL,4
        or      AL,byte ptr [Byte_3]
        cbw
        mov     [y_move],ax
        add     AX,word ptr [pos_y]
        js      Y_Zero
        cmp     AX,[y_max]
        jbe     Y_Set
        mov     AX,[y_max]
        jmp     Y_Set
Y_Zero: xor     ax,ax
Y_Set:  mov     [pos_y],AX

;   祭 ﭨ  
        mov     AL,[Byte_1]
        shr     AL,4
        mov     ah,al
        shr     ah,1
        shl     al,1
        and     ah,1
        and     al,2
        or      al,ah
        mov     ah,[Buttons]
        mov     [Buttons],AL
        and     ah,3
        and     al,3
        cmp     al,ah
        je      no_button_change
        xor     bx,bx
        push    ax
        test    al,2
        jz     no_right_button_change
        and     ah,2
        jz     right_button_pressed
        or      bx,16
        jmp     no_right_button_change
right_button_pressed:
        or      bx,8
no_right_button_change:
        pop     ax
        test    al,1
        jz     no_left_button_change
        and     ah,1
        jz     left_button_pressed
        or      bx,4
        jmp     no_left_button_change
left_button_pressed:
        or      bx,2
no_left_button_change:
        mov     [temp_mask],bx

no_button_change:
        mov     ax,[x_move]
        or      ax,[y_move]
        or      ax,ax
        jz      no_change_position
        or      word ptr [temp_mask],1

no_change_position:
        mov     ax,[temp_mask]
        and     ax,[user_mask]
        jz      no_call_user
        call    call_user_isr

no_call_user:
        cmp     byte ptr [sm_flag],1
        jne     no_show

        call    Get_Video_Adr
        mov     ax,word ptr es:[di]
        xor     ah,7fh
        stosw

no_show:

Isr_Quit:
        mov     al,20h
        out     20h,al
        pop     ds
        pop     es
        pop     bp
        pop     si
        pop     di
        pop     dx
        pop     cx
        pop     bx
        pop     ax
        iret

comaddres       dw      3f8h
comnumber       db      1
bytenumber      db      0
byte_1          db      0
byte_2          db      0
byte_3          db      0
first_time      db      1
buttons         db      0
pos_x           dw      319
pos_y           dw      99
sm_flag         dw      0
x_move          dw      0
y_move          dw      0
x_max           dw      639
y_max           dw      199
user_subroutine dw      0,0
user_mask       dw      0
temp_mask       dw      0

new_f6h:
        cli
        cmp     al,0
        je      reset_mouse
        cmp     al,1
        je      show_mouse
        cmp     al,2
        je      hide_mouse
        cmp     al,3
        je      get_pos
        cmp     al,4
        je      set_pos
        cmp     al,0bh
        je      get_mouse_movement
        cmp     al,0ch
        je      set_subroutines
        cmp     al,14h
        je      swap_subroutines
        iret

reset_mouse:
        jmp     _reset_mouse
show_mouse:
        jmp     _show_mouse
hide_mouse:
        jmp     _hide_mouse
get_pos:
        jmp     _get_pos
set_pos:
        jmp     _set_pos
get_mouse_movement:
        jmp     _get_mouse_movement
set_subroutines:
        jmp     _set_subroutines
swap_subroutines:
        jmp     _swap_subroutines

_reset_mouse:
        mov     byte ptr cs:[buttons],0
        mov     word ptr cs:[pos_x],319
        mov     word ptr cs:[pos_y],99
        mov     word ptr cs:[x_move],0
        mov     word ptr cs:[y_move],0
        mov     word ptr cs:[x_max],639
        mov     word ptr cs:[y_max],199
        mov     word ptr cs:[user_mask],0
        mov     word ptr cs:[user_subroutine],0
        mov     word ptr cs:[user_subroutine+2],0
        mov     ax,0ffffh
        mov     bx,3
        iret

_get_pos:
        mov     cx,word ptr cs:[pos_x]
        mov     dx,word ptr cs:[pos_y]
        mov     bx,word ptr cs:[buttons]
        xor     bh,bh
        iret

_get_mouse_movement:
        mov     cx,word ptr cs:[x_move]
        mov     dx,word ptr cs:[y_move]
        mov     word ptr cs:[x_move],0
        mov     word ptr cs:[y_move],0
        iret

_show_mouse:
        push    ax
        push    cx
        push    di
        push    es
        mov     byte ptr cs:[sm_flag],1
sub_s:  call    Get_Video_Adr
        mov     ax,word ptr es:[di]
        xor     ah,7fh
        stosw
        pop     es
        pop     di
        pop     cx
        pop     ax
        iret

_hide_mouse:
        push    ax
        push    cx
        push    di
        push    es
        mov     byte ptr cs:[sm_flag],0
        jmp     sub_s

_set_pos:
        mov     cx,cs:[pos_x]
        mov     dx,cs:[pos_y]
        mov     word ptr cs:[x_move],0
        mov     word ptr cs:[y_move],0
        iret

_set_subroutines:
        mov     word ptr cs:[user_subroutine],dx
        mov     word ptr cs:[user_subroutine+2],es
        mov     word ptr cs:[user_mask],cx
        iret

_swap_subroutines:
        push    word ptr cs:[user_mask]
        push    word ptr cs:[user_subroutine+2]
        push    word ptr cs:[user_subroutine]
        mov     word ptr cs:[user_subroutine],dx
        mov     word ptr cs:[user_subroutine+2],es
        mov     word ptr cs:[user_mask],cx
        pop     dx
        pop     es
        pop     cx
        iret

Get_Video_Adr:
        mov ax,0B800h
        mov es,ax
        mov cx,word ptr cs:[pos_y]
        shr cx,3
        mov ax,80
        mul cl
        mov di,ax
        mov ax,word ptr cs:[pos_x]
        shr ax,3
        add di,ax
        shl di,1
        ret

end_of_tsr:
        xor     ax,ax
        int     033h
        cmp     ax,0FFFFh
        jne     not_loaded

        mov     bp,offset already_loaded
        jmp     print

not_loaded:

        call    Find_Mouse
        mov     al,[COMNumber]
        cmp     al,3
        mov     bp,offset error_string
        je      Print

        add     al,30h
        mov     bp,offset intro_string
        mov     di,offset intro_string+5
        stosb
        call    Print

        mov     ax,0733h
        mov     di,offset new_f6h
        int     0F5h

        mov     ax,070Dh
        sub     al,[COMNumber]
        mov     di,offset new_isr
        int     0F5h

        mov     dx,si
        inc     dx
        in      al,dx
        or      al,1
        out     dx,al                   ; Enable Interrupt on COM Recive

        in      al,21h
        and     al,0EFh
        out     21h,al


        mov     ah,5
        mov     dx,offset end_of_tsr
        int     0F5h
        ret

Print:  mov     ah,4
        int     0F4h
        retn

Find_Mouse:
        cli
        mov     si,[COMAddres]
        in      al,21h
        or      al,10h
        out     21h,al
;
        mov     dx,si
        add     dx,3
        mov     al,0
        out     dx,al
        sub     dx,2
        in      al,dx
        mov     ah,al
        and     ah,0F0h
        add     dx,3
        in      al,dx
        and     al,0E0h
        or      ah,al
        jnz     NoMouse
;
        mov     al,80h
        mov     dx,si
        add     dx,3
        out     dx,al                   ; set DLAB on (Service)
        mov     al,60h
        mov     dx,si
        out     dx,al                   ; set port speed 1200 bps
        mov     al,0
        mov     dx,si
        add     dx,1
        out     dx,al
        mov     al,2
        mov     dx,si
        add     dx,3
        out     dx,al                   ; 7 bit data 1 stop bit
        mov     al,0
        mov     dx,si
        add     dx,1
        out     dx,al                   ; all serial port interrupts off
        mov     al,1
        mov     dx,si
        add     dx,4
        out     dx,al                   ; DTR signal ON (mouse power on)
        xor     cx,cx

Delay1: loop    Delay1                  ; delay for enable mouse scheme

        mov     dx,si
        add     dx,5
        in      al,dx

        mov     al,0Bh
        mov     dx,si
        add     dx,4
        out     dx,al                   ; enable mouse interface
        jmp     short $+2
        mov     dx,si
        in      al,dx

        xor     bx,bx
Delay2:
        xor     cx,cx
Delay3:
        mov     dx,si
        add     dx,5
        in      al,dx                   ; read port status
        jmp     short $+2
        and     al,1
        or      al,al
        jnz     Next_L                  ; mouse made answer?
        loop    Delay3
        jmp     NoMouse

Next_L:
        mov     dx,si
        in      al,dx
        cmp     al,'M'                  ; Check answer for 'Mouse' device
        je      EndSearch               ; Yes! Mouse present! Exit now...
        inc     bx
        cmp     bx,4
        jb      Delay2
        jmp     NoMouse

NoMouse:
        inc     [COMNumber]             ; next COM port number
        cmp     [COMNumber],2           ; check only COM1 and COM2
        ja      EndSearch
        sub     [COMAddres],100h        ; next COM port addres
        jmp     Find_Mouse

EndSearch:
        sti
        retn

intro_string    db 13,10,'COM1 Mouse driver installed!',13,10,'$'
error_string    db 13,10,'Mouse not found on COM port!',13,10,'$'
already_loaded  db 13,10,'Mouse driver already loaded!',13,10,'$'

        end begin
